﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ConsoleApplication1
{

    class Financeira
    {
        /**
         * Método: Juros
         * 
         * Descrição:
         *   Calcula o juros produzido por uma aplicação de capital (c)
         *   a taxa de juros (i) por um período n
         * 
         * Parâmetros:
         * decimal c: Capital
         * decimal i: Taxa de juros
         * int n: número de períodos
         * 
         * Retorno:
         *   decimal valor do juros
         * 
         */
        public static decimal Juros(decimal c, decimal i, int n)
        {
            decimal j = c * (i / 100) * n;
            return j;
        }

        /**
         * Método: Montante
         * 
         * Descrição:
         *   Calcula o montante produzido por uma aplicação de capital (c)
         *   a taxa de juros (i) por um período n
         * 
         * Parâmetros:
         *   decimal c: Capital
         *   decimal i: Taxa de juros
         *   int n: número de períodos
         * 
         * Retorno:
         *   decimal valor do montante acumulado
         * 
         */
        public static decimal Montante(decimal c, decimal i, int n)
        {
            decimal m = c * (1 + ((i / 100) * n));
            return m;
        }

        public static void Main()
        {
            decimal capital;
            decimal taxa;
            int periodo;

            /*
            capital = 1000;
            taxa = 1;
            periodo = 12;
             */

            Console.Write("Entre com o capital (C): ");
            capital = decimal.Parse(Console.ReadLine());
            Console.Write("Entre com o taxa de juros (i) (para 5%, entre 5): ");
            taxa = decimal.Parse(Console.ReadLine());
            Console.Write("Entre com o número de períodos (n): ");
            periodo = int.Parse(Console.ReadLine());

            Console.WriteLine("Juro={0}", Juros(capital, taxa, periodo));

            Console.WriteLine("Montante={0}", Montante(capital, taxa, periodo));

        }

    }
}
