﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ConsoleApplication1
{
    class MaiorMenorDeArray
    {
        /**
         * Método: MaiorMenor
         * 
         * Parâmetros:
         *   double[] lista
         *   out double maior
         *   out double menor
         * 
         * Retorna:
         *   boolean false --> se a lista estiver vazia
         *           true --> lista está preenchida
         * 
         */
        public static bool MaiorMenor(double[] lista, out double maior, out double menor)
        {
            if (lista.Length == 0)
            {
                // lista sem nenhum elemento
                maior = 0; menor = 0;
                return false;
            }

            // inicia o maior e o menor elemento da lista
            maior = menor = lista[0];
            
            // percorre todos os elementos da lista
            foreach(double num in lista) {
                if (num > maior)
                {
                    // atualiza o maior elemento
                    maior = num;
                }
                if (num < menor)
                {
                    // atualiza o menor elemento
                    menor = num;
                }
            }

            
            return true;

        }

        public static void Main(string[] args)
        {
            double[] d = { 1, 4, 3, 2, 5, 7, 6, 9, 8 };
            double maior;
            double menor;

            bool res = MaiorMenor(d, out maior, out menor);

            Console.WriteLine("res={2}, maior={0}, menor={1}", maior, menor, res);
            
            res = MaiorMenor(new double[0], out maior, out menor);

            Console.WriteLine("res={2}, maior={0}, menor={1}", maior, menor, res);
        }
    }
}
