﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ConsoleApplication1
{
    class MergeArrays
    {
        /*
         * Método: merge
         * 
         * Cria e retorna um novo vetor contendo o merge entre os vetores
         * a e b (a e b devem estar previamente ordenados)
         * 
         * Parâmetros:
         *   int[] a
         *   int[] b
         *   int[] c out
         * 
         * Retorno:
         *   void
         *   
         */
        public static void merge(int[] a, int[] b, out int[] c)
        {
            // obtem o numero de elementos do array a
            int numA = a.Length;

            // obtem o numero de elementos do array b
            int numB = b.Length;

            // cria um novo array para conter o número de elementos de a e b
            int numC = numA + numB;

            c = new int[numC];

            // vamos trabalhar com três ponteiros (índices)
            // um para percorrer o array a
            // um para percorrer o array b
            // um para percorrer o array c
            int i = 0;
            int j = 0;
            int k = 0;

            // as variáveis fimA e fimB indicam o término do
            // processamento dos arrays a e b
            bool fimA = false;
            bool fimB = false;

            fimA = (numA == 0);
            fimB = (numB == 0);

            // o loop será encerrado se todos os elementos forem copiados
            // ou terminarmos de percorrer um dos arrays. Nesse caso,
            // os elementos ou outro array serão copiados
            while ((k < numC) && (!(fimA || fimB)))
            {

                // obtem o próximo elementos do
                // array c

                if (a[i] < b[j])
                {
                    // elemento de a menor que elemento de b
                    // c recebe o elemento de a na posição k (menor elemento)
                    c[k] = a[i];
                    Console.WriteLine("i={0},j={1},k={2},a[{3}]={4},b[{5}]={6},c[{7}]={8}", i, j, k, i, a[i], j, b[j], k, c[k]);
                    // avança uma posição no vetor a
                    i++;
                    // avança uma posição no vetor c
                    k++;
                }
                else if (a[i] >= b[j])
                {
                    // elemento de a maior ou igual ao elemento de b
                    // c recebe o elemento de b na posição k (menor elemento)
                    c[k] = b[j];
                    Console.WriteLine("i={0},j={1},k={2},a[{3}]={4},b[{5}]={6},c[{7}]={8}", i, j, k, i, a[i], j, b[j], k, c[k]);

                    // avança uma posição no vetor a
                    j++;
                    // avança uma posição no vetor b
                    k++;
                }

                // verifica o término de a
                fimA = (i >= numA);
                // verifica o término de b
                fimB = (j >= numB);

            }

            if (fimB)
            {
                // todos elementos do array b foram copiados
                while (i < numA)
                {
                    // copia dos elementos faltantes do array a
                    c[k] = a[i];
                    Console.WriteLine("i={0},k={1},a[{2}]={3},c[{4}]={5}", i, k, i, a[i], k, c[k]);
                    i++;
                    k++;
                }
            }
            else if (fimA)
            {
                // todos elementod do array a foram copiados
                while (j < numB)
                {
                    // copia dos elementos faltantes do array b
                    c[k] = b[j];
                    Console.WriteLine("j={0},k={1},b[{2}]={3},c[{4}]={5}", j, k, j, b[j], k, c[k]);
                    j++;
                    k++;
                }
            }
            else
            {
                //
                Console.WriteLine("ok");
            }

        }

        /*
         * Exibe o array
         */
        public static void mostra(int[] a)
        {
            Console.WriteLine("Numero de elementos do array={0}", a.Length);
            for (int i = 0; i < a.Length; i++)
            {
                //
                Console.Write("{0}\t", a[i]);
            }
            Console.WriteLine("\n");
        }

        public static void Main()
        {
            //int[] a = { 1, 3, 8, 13, 19, 21, 22, 23 };
            //int[] b = { 2, 4, 5, 6, 7, 9, 10, 11, 12 };

            //int[] a={1, 3};
            //int[] b={2,4,5};

            //int[] a={1};
            //int[] b={2,4};

            //int[] a={1, 3};
            //int[] b={2, 4};

            //int[] a = { 1, 2, 3, 4 };
            //int[] b = { };

            //int[] a = { };
            //int[] b = { 1, 2, 3, 4 };

            //int[] a = { 3, 4};
            //int[] b = { 1, 2};

            //int[] a = { };
            //int[] b = { };

            //int[] a = { 2 };
            //int[] b = { 1 };

            //int[] a = { -4, -1, 0, 7, 8};
            //int[] b = { -5, -3, -2, -1, 0, 9};

            int[] a = { 0, 1, 3, 4, 5, 7 };
            int[] b = { 2, 6, 8, 9 };

            int[] c;
            mostra(a);
            mostra(b);
            merge(a, b, out c);
            mostra(c);
        }
    }
}
